; mouse change routine by rayden
;
;
;
;we must change the mouse in the edit area



mouse_driver_init:
    LD   BC,memory_area_end - memory_area
    .org $9D94
mouse_driver_main:
_mouse_changed_sprite .equ _SmallEditRam + 23
_mouse_save           .equ _SmallEditRam + 47 
    LD   A,(backgroud_status1)
    OR   A \ jr  nz,don't_add_background
    LD   A,1
    LD   (backgroud_status1),A
    LD   HL,background_happen
    xor  a
    invoke( ADD_program_to_background )    
don't_add_background:
    LD   A,(check_cursor_status)
    CP   1 \ jr   z,cursor_already_saved
    LD   A,1
    LD   (check_cursor_status),A;use this for saving the data 
    LD   HL,_mouse_changed_sprite
    LD   DE,_mouse_save;we will use mouse_save data ram area
    LD   BC,8
    LDIR ;save it now
    ;now we must copy it to the new cursor
    LD   HL,_mouse_changed_sprite
    LD   DE,new_cursor
    LD   BC,8
    LDIR
cursor_already_saved:
    xor  a 
    invoke( save_screen );save the screen 
    call create_edit_window
    xor  a
    invoke( mouse_sprite );for not having the screen destroyed
mouse_edit_loop:    
    call check_edit_area
    CP   1 \ jr  z,change_to_macrodie_mouse
put_edit_cursor:
    LD   A,(edit_cursor_status)
    CP   1 \ jr   z,cursor_already_in_edit_mode;do not change it
    xor  a
    invoke( mouse_sprite )
    LD   HL,_edit_cursor
    LD   DE,_mouse_changed_sprite
    LD   BC,8
    LDIR ;copy it
    xor  a
    invoke( mouse_sprite );update the cursor
    xor  a
    invoke( fastcopy )
cursor_already_in_edit_mode:
    LD   A,1
    LD   (edit_cursor_status),A
    jr   continue_mouse
change_to_macrodie_mouse:
    LD   A,(edit_cursor_status)
    CP   2 \ jr   z,cursor_already_in_macrodie_mode
    xor  a
    invoke( mouse_sprite )
    LD   HL,_mouse_save
    LD   DE,_mouse_changed_sprite
    LD   BC,8
    LDIR ;copy it
    xor  a
    invoke( mouse_sprite )
    xor  a
    invoke( fastcopy )
cursor_already_in_macrodie_mode:
    LD   A,2
    LD   (edit_cursor_status),A
continue_mouse:
    call check_shift_buttons_area
    xor  a
    invoke( loop2 ); call the interrupted mouse routine
    CP   1
    jr   z,second_key_have_been_pressed
    jr   mouse_edit_loop
second_key_have_been_pressed:
    ;what happen ?  
    ;first check the window
    xor   a
    invoke( window_verif_coords )
    LD    A,B;code comes in B
    CP    1 \ jr   z,close_task_driver
    CP    2 \ jr   z,minimizate_task_driver;minimizate button
    CP    5 \ jr   z,minimizate_task_driver;task bar??
    call  verif_icone's;if it is an icone then perform action
    call  verif_button's
    call  verif_grelha_1
    jr    continue_mouse
    
    
close_task_driver:
    LD   B,40
_port_delay1s:
    EI
    HALT
    DJNZ _port_delay1s    
    xor  a
    invoke( restore_screen )
    LD   A,(activ_task)
    LD   (close_task),A ;ordem ao windows para fechar task     
    XOR  A
    LD   (activ_task),A
    LD   (screen),A ;erro causado por causa desta variavel
    LD   (animar_flag),A
    RET  ;volto ao windows 
minimizate_task_driver:
    xor   a
    invoke( restore_screen )
    XOR   A
    
    LD    (activ_task),A
    LD    (screen),A ; se nao apagarmos esta variavel o sistema recusa e desliga
    LD    (close_task),A
    RET
verif_button's:
    call  get_button_number;get the button number
    OR    A;if zero no button
    RET   Z
    CP    2 \ jp  z,shift_up
    CP    4 \ jp  z,shift_left
    CP    6 \ jp  z,shift_right
    CP    8 \ jp  z,shift_down    
    RET
verif_grelha_1:
    LD    A,(ypos);get the ypos
    CP    35 \ jr  nc,its_not_grelha
    CP    10 \ jr   c,its_not_grelha 
    LD    A,(xpos)
    CP    3   \ jr   c,its_not_grelha
    CP    28  \ jr   nc,its_not_grelha
verif_grelha:
    ;first get the y value for we to know the line
    LD    A,(ypos);get the ypos
    CP    35 \ jr  nc,its_not_grelha
    CP    10 \ jr   c,its_not_grelha 
    SUB   10
    ;check second line
    LD    B,8;8 lines to check
    LD    D,1
checking_lines:
    SUB   3;SUB   E ;i don't know whay but this is gaving me an error when compiling
             ; because it will put A3 the code of AND D
    CP    $80
    jr    nc,line_found
    INC   D
    DJNZ  checking_lines
its_not_grelha:
    EI
    LD   B,5
_delay_port:
    halt
    DJNZ _delay_port;create an delay between acssess's    
    RET;go back
line_found:;the line comes into D
;now check the colum
    LD    A,(xpos)
    CP    3   \ jr   c,its_not_grelha
    CP    28  \ jr   nc,its_not_grelha  
    SUB   3
    CP    $80 \ jr  nc,its_not_grelha
    
    LD    B,8
    LD    C,1
checking_colum:
    SUB   3
    CP    $80
    jr    nc,colum_found
    INC   C
    DJNZ  checking_colum
    jr    its_not_grelha
colum_found:
    ;now get that bit and change it
    ;D have the line and C the bit 
    PUSH BC
    PUSH DE
    call refresh_screen;put the image on screen
    POP  DE
    POP  BC
    DEC  D;we must decrement in order for get the line in a good way
    LD   E,D
    LD   D,0
    LD   HL,new_cursor
    ADD  HL,DE;get that line
    LD   A,(HL)
    ;now get the bit
    ;so how the hell will i got that bit
    ;simple using an rotation of x bits
    LD   B,C
get_bit
    RL   A;now i will get that bit
    DJNZ get_bit
    ;so now i have that bit in carry flag 
    ;if set we must unset it
    jr   c,unset
    SCF  ;we must set it
    jr   restore_byte
unset:
    SCF \ CCF ;we must reset carry flag
restore_byte:
    LD   B,C;now restore the byte but with the bit changed
change_bit:
    RR   A;so we rotate right A
    DJNZ change_bit;bit have been change 
    LD   (HL),A;now save the byte with bit changed
    ;now update screen with the new bit
    call refresh_screen
    xor  a
    invoke( fastcopy )
    LD   A,$FF
    OUT  (1),A;reset KeyPort
    jr   its_not_grelha

refresh_screen:
    LD   H,3;coords start
    LD   L,10
    LD   A,1
    LD   B,64;64 bits to display
    LD   DE,new_cursor
refreshing_screen:
    PUSH BC;save BC
    
    PUSH HL
    
    
    LD   IX,point_sprite
    
    PUSH IX
    
    PUSH DE
    PUSH AF
    LD   A,(DE)
    POP  BC
    PUSH BC
_get_the_right_bit:
    RL   A
    djnz _get_the_right_bit
    jr   nc,do_not_display_it
    LD   B,2
    LD   C,1
    xor  a
    invoke( putsprite )
do_not_display_it:
    POP  AF
    
    POP  DE
    
    POP  IX
   
    POP  HL
    
    POP  BC
    INC  H
    INC  H
    INC  H
    CP   8 \ call  z,change_line
    INC  A
    DJNZ refreshing_screen
    RET
change_line:
    LD   H,3
    INC  L
    INC  L
    INC  L
    LD   A,0
    INC  DE;next line
    RET
    
    
check_edit_area:
    LD   A,(ypos)
    CP   10 \ jr  c,erase_edit_cursor
    CP   36 \ jr  nc,erase_edit_cursor
    LD   A,(xpos)
    CP   2 \ jr   c,erase_edit_cursor
    CP   28 \ jr  nc,erase_edit_cursor
    LD   A,2
    RET
erase_edit_cursor:
    LD   A,1
    RET
    
    


create_edit_window:
    xor   a
    invoke( create_default_pasta )
    ;now draw the 'grelha'
    LD   B,9
    LD   A,2
draw_vertical:
    ;37+2=39
    PUSH BC
    LD   B,A
    LD   D,A
    LD   C,54
    LD   E,31
    LD   H,1
    PUSH AF
    bcall _ILine
    POP  AF
    ADD  A,3
    POP  BC
    DJNZ draw_vertical
    LD   B,9
;now draw horizontal
    LD   A,54
draw_horizontal:
    PUSH BC
    LD   B,2
    LD   D,20+3+3
    LD   C,A
    LD   E,A
    PUSH AF
    LD   H,1
    bcall _ILine
    POP  AF
    SUB  3
    POP  BC
    DJNZ draw_horizontal
    call refresh_screen
    ;now draw the buttons
    call draw_3_buttons
    call draw_mov_buttons
    xor  a
    invoke( fastcopy )
    RET
    
draw_3_buttons:
    LD   H,11+2
    LD   L,34+8
    LD   B,8
    LD   C,2
    LD   IX,apply
    xor  a
    invoke( putsprite )
    LD   H,11+2+16+11
    LD   L,34+8
    LD   B,8
    LD   C,2
    LD   IX,reset
    xor  a
    invoke( putsprite )
    LD   H,11+2+16+11+16+11
    LD   L,34+8
    LD   B,8
    LD   C,2
    LD   IX,cancel
    xor  a
    invoke( putsprite )
background_happen: ;well as i will not need for running any background code i will use this ret for ending it    
    RET;go back
    
draw_mov_buttons:
    LD   H,64
    LD   L,14
    LD   B,8
    LD   C,1
    LD   IX,seta_cima;draw seta cima
    xor  a
    invoke( putsprite )     
    LD   H,56
    LD   L,22
    LD   B,8
    LD   C,1
    LD   IX,seta_esquerda
    xor  a
    invoke( putsprite )
    LD   H,64
    LD   L,30
    LD   C,1
    LD   B,8
    LD   IX,seta_baixo
    xor  a
    invoke( putsprite )
    LD   H,72
    LD   L,22
    LD   C,1
    LD   B,8
    LD   IX,seta_direita
    xor  a
    invoke( putsprite )
    RET;buttons drawned
    
check_shift_buttons_area:
    ;check the buttons area and change them if mouse over
    ;first convert the coords into a matrix
    ;
    ;  1  2  3-> linha 1
    ;  4  5  6-> linha 2
    ;  7  8  9-> linha 3
    ;      
;the numbers that we want are 2 4 6 8 the rest doesn't matter
    call  get_button_number
    CP    2 \ jr   z,invert_2
    CP    4 \ jp   z,invert_4
    CP    6 \ jp   z,invert_6
    CP    8 \ jp   z,invert_8
    ; else check the button status if zero skip of erase
    LD    A,(button_status)
    OR    A
    jr    z,skip_erase
    ;first i need to check the button to erase
    LD    A,(button_1_status)
    OR    A
    jr    z,not_this_one
    LD   H,56
    LD   L,22
    LD   B,8
    LD   C,1
    LD   IX,seta_esquerda_selecionar;draw seta cima
    XOR  A
    LD    (button_1_status),A
    call  draw
not_this_one:    
    LD   A,(button_2_status)
    OR   A
    jr   z,not_this_one1
    LD   H,72
    LD   L,22
    LD   C,1
    LD   B,8
    LD   IX,seta_direita_selecionar;draw seta cima
    XOR   A
    LD    (button_2_status),A
    call  draw
    
not_this_one1:    
    LD   A,(button_3_status)
    OR   A
    jr   z,not_this_one2
    LD   H,64
    LD   L,30
    LD   C,1
    LD   B,8
    LD   IX,seta_baixo_selecionar;draw seta cima
    XOR   A
    LD    (button_3_status),A
    call  draw
    
not_this_one2:
    LD   A,(button_4_status)
    OR   A
    jr   z,skip_erase
    LD   H,64
    LD   L,14
    LD   B,8
    LD   C,1
    LD   IX,seta_cima_selecionar;draw seta cima
    xor  a
    LD    (button_4_status),A
    call  draw
continue_erasing:
    XOR    A
    LD    (button_status),A
skip_erase:
    RET
    
invert_2:
    LD   A,1
    LD   (button_status),A    
    LD   A,(button_4_status)
    OR   A
    jr   nz,skip_erase
    LD   A,1
    LD   (button_4_status),A
    LD   H,64
    LD   L,14
    LD   B,8
    LD   C,1
    LD   IX,seta_cima_selecionar;draw seta cima
draw:    
    xor  a
    invoke( putsprite )
    xor  a
    invoke( fastcopy )
    RET
invert_4:
    LD   A,1
    LD   (button_status),A
    LD   A,(button_1_status)
    OR   A
    jr   nz,skip_erase
    LD   A,1
    LD   (button_1_status),A            
    LD   H,56
    LD   L,22
    LD   B,8
    LD   C,1
    LD   IX,seta_esquerda_selecionar;draw seta cima
    jr   draw
invert_6:
    LD   A,1
    LD   (button_status),A    
    LD   A,(button_2_status)
    OR   A
    jr   nz,skip_erase
    LD   A,1
    LD   (button_2_status),A
    LD   H,72
    LD   L,22
    LD   C,1
    LD   B,8
    LD   IX,seta_direita_selecionar;draw seta cima
    jr   draw
invert_8:
    LD   A,1
    LD   (button_status),A    
    LD   A,(button_3_status)
    OR   A
    jr   nz,skip_erase
    LD   A,1
    LD   (button_3_status),A
    LD   H,64
    LD   L,30
    LD   C,1
    LD   B,8
    LD   IX,seta_baixo_selecionar;draw seta cima
    jr   draw
    
    
    
get_button_number:
    LD    A,(xpos)
    CP    56 \ jr    c,out_of_matrix
    CP    80 \ jr    nc,out_of_matrix
    LD    A,(ypos);the ypos of the start of the buttos is 14
    ;get the line
    CP    14 \ jr    c,out_of_matrix
    CP    38 \ jr    nc,out_of_matrix
    SUB   14;
    CP    $80 \ jr   z,out_of_matrix
    LD    D,1;start at 1
    LD    B,3
get_matrix_line:
    SUB   8;eatch button is 8x8
    CP    $80 \ jr   nc,matrix_line_found
    INC   D
    DJNZ  get_matrix_line
out_of_matrix:
    XOR   A;button number is zero
    RET
matrix_line_found:
;now check the colum
    LD    B,3
    LD    A,(xpos)
    SUB   56;start of matrix
    CP    $80 \ jr  nc,out_of_matrix
    LD    C,1
get_matrix_colum:
    SUB   8
    CP    $80
    jr    nc,matrix_colum_found
    INC   C
    DJNZ  get_matrix_colum
    jr    out_of_matrix
matrix_colum_found:
    XOR   A
    DEC   D
    LD    B,D
get_number_of_adds:
    ADD   A,3
    djnz  get_number_of_adds
now_add:
    ADD   A,C
    RET
shift_up:
    ;lets shift up the sprite but first we have to erase it
    call  refresh_screen
    LD    DE,new_cursor
    LD    A,(DE)
    LD    HL,new_cursor+1
    LD    BC,7
    LDIR
    LD    HL,new_cursor+7
    LD    (HL),A
continue_shift
    call  refresh_screen
    xor   a
    invoke( fastcopy )
    RET
    
shift_left:
    call refresh_screen
    LD    HL,new_cursor
    LD    B,8
_shift_left_loop:
    LD    A,(HL)
    RLC    A
    LD    (HL),A
    INC   HL
    DJNZ  _shift_left_loop
    jp    continue_shift

    







shift_right:
    call refresh_screen
    LD    HL,new_cursor
    LD    B,8
_shift_right_loop:
    LD    A,(HL)
    RRC    A
    LD    (HL),A
    INC   HL
    DJNZ  _shift_right_loop
    jp    continue_shift
    
    
    
    
shift_down:
    call  refresh_screen
    LD    HL,new_cursor+6
    LD    DE,new_cursor+7
    LD    A,(DE)
    LD    BC,7
    LDDR     
    LD    HL,new_cursor
    LD    (HL),A
    jp    continue_shift
    

verif_icone's
;lets check the button's
    LD    A,(ypos);check the line of the ypos
    CP    34+8
    jr    c,no_buttons;could be verif grelha or not
    CP    34+8+8
    jp    nc,no_buttons;maybe barra de tarefas
    LD    A,(xpos)
    CP    2+11 \ jp  c,no_buttons
    CP    2+11+16 \ jr  nc,verif_reset_icone
aplly_icone:
    ;prepare for saving data
    ;the data is on new_cursor
    LD    HL,new_cursor;get the new cursor and prepare for a program restart
    LD    DE,_mouse_changed_sprite
    LD    BC,8
    LDIR
    LD    HL,new_cursor
    LD    DE,_mouse_save
    LD    BC,8
    LDIR
    POP   DE
    jp    mouse_driver_main;lets restart the program
verif_reset_icone:
    CP    2+11+16+11
    jr    c,no_buttons
    CP    2+11+16+11+16
    jr    nc,verif_cancel_icone
reset_icone:
    LD    HL,default_icone;get the default cursor and prepare for a program restart
    LD    DE,_mouse_changed_sprite
    LD    BC,8
    LDIR
    LD    HL,default_icone
    LD    DE,new_cursor
    LD    BC,8
    LDIR
    POP   DE
    jp    mouse_driver_main;lets restart the program
verif_cancel_icone:
    CP    2+11+16+11+16+11
    jr    c,no_buttons
    CP    2+11+16+11+16+11+16
    jr    nc,no_buttons
cancel_icone:;prepare for exiting the program    
    POP   HL;the return address
    jp    close_task_driver
no_buttons:
    RET     
   


memory_area:

_edit_cursor:
.db %11100000
.db %11110000
.db %10011000
.db %01001100
.db %00100110
.db %00010011
.db %00001010
.db %00000100

point_sprite:
.db %11000000
.db %11000000


new_cursor:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000

cancel:
.db %00111111, %11111100
.db %01000000, %00000010
.db %10011001, %00100101
.db %10100010, %10110101
.db %10100011, %10101101
.db %10011010, %10100101
.db %01000000, %00000010
.db %00111111, %11111100

apply:
.db %00111111, %11111100
.db %01000000, %00000010
.db %10010011, %00110001
.db %10101010, %10101001
.db %10111011, %00110001
.db %10101010, %00100001
.db %01000000, %00000010
.db %00111111, %11111100

reset:
.db %00111111, %11111100
.db %01000000, %00000010
.db %10011001, %11011001
.db %10010101, %10010001
.db %10011001, %00001001
.db %10010101, %11011001
.db %01000000, %00000010
.db %00111111, %11111100

default_icone:
.db %11100000
.db %11000000
.db %10100000
.db %00010000
.db %00000000
.db %00000000
.db %00000000
.db %00000000

seta_esquerda:
.db %00001100
.db %00010100
.db %00100111
.db %01000001
.db %01000001
.db %00100111
.db %00010100
.db %00001100

seta_esquerda_selecionar:
.db %00001100
.db %00011100
.db %00111111
.db %01111111
.db %01111111
.db %00111111
.db %00011100
.db %00001100

seta_direita:
.db %00110000
.db %00101000
.db %11100100
.db %10000010
.db %10000010
.db %11100100
.db %00101000
.db %00110000

seta_direita_selecionar:
.db %00110000
.db %00111000
.db %11111100
.db %11111110
.db %11111110
.db %11111100
.db %00111000
.db %00110000

seta_cima:
.db %00000000
.db %00011000
.db %00100100
.db %01000010
.db %10000001
.db %11100111
.db %00100100
.db %00111100
seta_cima_selecionar:
.db %00000000
.db %00011000
.db %00111100
.db %01111110
.db %11111111
.db %11111111
.db %00111100
.db %00111100
seta_baixo:
.db %00111100
.db %00100100
.db %11100111
.db %10000001
.db %01000010
.db %00100100
.db %00011000
.db %00000000
seta_baixo_selecionar:
.db %00111100
.db %00111100
.db %11111111
.db %11111111
.db %01111110
.db %00111100
.db %00011000
.db %00000000


backgroud_status1   .db 0
check_cursor_status .db 0
edit_cursor_status  .db 0
button_status:      .db 0
button_1_status     .db 0
button_2_status     .db 0
button_3_status     .db 0
button_4_status     .db 0
memory_area_end:
.end
.end