#include "ti83plus.inc"
#include "macrodie.inc"
.org $9D95
;structure for one macrodie program
    RET;for preventing ti-os to execute it 
    jr start
    LD   BC,end_of_vars - start_of_vars;this reports to macrodie the size of the variables
icon:;icon of the prog to disp on the folder
;16 , 16
.db %00000000, %00000000
.db %00000011, %10000000
.db %00000010, %01100000
.db %00000010, %00110000
.db %00000010, %00001000
.db %00001111, %00001000
.db %00011001, %00001100;you should edit this to your icon
.db %00000001, %10000100
.db %00000000, %10000100
.db %00110000, %10110000
.db %00100000, %10001111
.db %00000001, %10000000
.db %00000111, %00000000
.db %00011011, %10000000
.db %00011110, %10001000
.db %00000000, %10001100
    
start:;start of code for macrodie 
    LD   A,(background_program_status)
    CP   1 \ jr   z,program_already_added
    LD   A,1
    LD   (background_program_status),A
    LD   HL,background_task
    xor  a;macrodie page
    invoke( ADD_program_to_background )
;===========================================
;======== Your Code Begins Here ============
;============================================      
program_already_added:;main control begins here
    xor   a
    invoke( create_default_pasta );criamos uma pasta de servico
    xor   a
    invoke( mouse2 );call mouse  
looping_return:
    xor   a
    invoke( loop2 );call mouse loop don't affect screen unless modification of coords
    bit   0,A
    jr    z,looping_return
    xor   a
    invoke( window_verif_coords )
    LD    A,B
    CP    1 \ jr  z,prog_finished
minimizate_window:
    XOR  A
    LD   (activ_task),A
    LD   (close_task),A ;ordem ao windows para fechar task activa
    LD   (screen),A
    LD   (animar_flag),A
    RET;return to macrodie
    

prog_finished:
    LD   A,(activ_task)
    LD   (close_task),A ;ordem ao windows para fechar task activa   
    XOR  A
    LD   (activ_task),A
    LD   (screen),A
    LD   (animar_flag),A
    RET  ;volto ao windows





;====================================================
;==== This is what your program execute allways =====
;====================================================
;this is the routine that your program is executing on idle
;the code in here shouldn't access to the screen not even the keyboard
background_task:
     RET
     
;=======================================================
;==== This area is reserverd for your programs vars ====
;======================================================= 
start_of_vars:
background_program_status .db 0 ;this reports to the main code routine if the program have been already added to background
;do not change this variable
;======================================================
;============ start of your variables field ===========
;======================================================
          



end_of_vars:
;======================================================
;=========== end of your variables field ==============
;======================================================